<?php

namespace classes;

use phpcommon;

class AddReward {
    protected function getMysql($account_id)
    {
        $mysql_conf = getMysqlConfig(crc32($account_id));
        $conn = new phpcommon\Mysql(array(
            'host' => $mysql_conf['host'],
            'port' => $mysql_conf['port'],
            'user' => $mysql_conf['user'],
            'passwd' => $mysql_conf['passwd'],
            'dbname' => 'gamedb2002_' . $mysql_conf['instance_id']
        ));
        return $conn;
    }

    public function addReward($item_id, $item_num, $account_id)
    {
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            die();
        }
        if ($item_id == 10001) {
            $row1 = $conn->execQueryOne('SELECT coin_num FROM user WHERE accountid=:accountid;',
                                        array(
                                            ':accountid' => $account_id
                                        ));
            $ret = $conn->execScript('UPDATE user SET coin_num=:coin_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':coin_num' => $item_num + $row1['coin_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        } else if ($item_id > 17000 && $item_id < 18000) {
            $rowCommander = $conn->execQueryOne('SELECT fragment_num FROM commander WHERE accountid=:accountid AND fragment_id=:fragment_id;',
                                           array(
                                               ':accountid' => $account_id,
                                               ':fragment_id' => $item_id
                                           ));
            $ret = $conn->execScript('UPDATE commander SET fragment_num=:fragment_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid AND fragment_id=:fragment_id;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':fragment_id' => $item_id,
                                         ':fragment_num' => $item_num + $rowCommander['fragment_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        } else if ($item_id == 10002) {
            $rowkey = $conn->execQueryOne('SELECT keys_num FROM user WHERE accountid=:accountid;',
                                          array(
                                              ':accountid' => $account_id
                                          ));
            $ret = $conn->execScript('UPDATE user SET keys_num=:keys_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':keys_num' => $item_num + $rowkey['keys_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        } else if ($item_id == 10003) {
            $rowDiamond = $conn->execQueryOne('SELECT diamond_num FROM user WHERE accountid=:accountid;',
                                              array(
                                                  ':accountid' => $account_id
                                              ));
            $ret = $conn->execScript('UPDATE user SET diamond_num=:diamond_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':diamond_num' => $item_num + $rowDiamond['diamond_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        } else if ($item_id > 16000 && $item_id < 17000) {
            $rowTank = $conn->execQueryOne('SELECT fragment_num FROM tank WHERE accountid=:accountid AND fragment_id=:fragment_id;',
                                           array(
                                               ':accountid' => $account_id,
                                               ':fragment_id' => $item_id
                                           ));
            $ret = $conn->execScript('UPDATE tank SET fragment_num=:fragment_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid AND fragment_id=:fragment_id;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':fragment_id' => $item_id,
                                         ':fragment_num' => $item_num + $rowTank['fragment_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
            }
        }
    }

    public function updateReward($item_id, $item_num, $account_id)
    {
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            die();
        }
        $ret = $conn->execScript('UPDATE sign SET item_id=:item_id, item_num=:item_num, modify_time=:modify_time ' .
                                 ' WHERE accountid=:accountid;',
                                 array(
                                     ':accountid' => $account_id,
                                     ':item_id' => $item_id,
                                     ':item_num' => $item_num,
                                     ':modify_time' => time()
                                 ));
        if (!$ret) {
            die();
        }
    }
}
?>
