<?php

require 'classes/Quest.php';
require 'classes/AddReward.php';

class SignController{

    protected function getMysql($account_id)
    {
        $mysql_conf = getMysqlConfig(crc32($account_id));
        $conn = new phpcommon\Mysql(array(
            'host' => $mysql_conf['host'],
            'port' => $mysql_conf['port'],
            'user' => $mysql_conf['user'],
            'passwd' => $mysql_conf['passwd'],
            'dbname' => 'gamedb2002_' . $mysql_conf['instance_id']
        ));
        return $conn;
    }

    protected function getSign($sign_id)
    {
        $sign_meta_table = require('../res/signDaily@signDaily.php');
        $sign_meta = getSignConfig($sign_meta_table, $sign_id);
        $s = array(
            'sign_id' => $sign_meta['sign_id'],
            'condition' => $sign_meta['condition'],
            'item_id' => $sign_meta['item_id'],
            'num' => $sign_meta['num'],
        );
        return $s;
    }

    protected function getParameter($para_id)
    {
        $parameter_meta_cluster = require('../res/parameter@parameter.php');
        $parameter_meta = getParameterConfig($parameter_meta_cluster, $para_id);
        $p = array(
            'id' => $parameter_meta['id'],
            'param_name' => $parameter_meta['param_name'],
            'param_value' => $parameter_meta['param_value'],
        );
        return $p;
    }

    public function signInfo()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        $sign_days = 0;
        $signable = 1;
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $row1 = $conn->execQueryOne('SELECT * FROM user WHERE accountid=:accountid;',
                                    array(
                                        ':accountid' => $account_id
                                    ));

        $row = $conn->execQueryOne('SELECT * FROM sign WHERE accountid=:accountid;',
                                   array(
                                       ':accountid' => $account_id
                                   ));
        $nowTime = phpcommon\getdayseconds(time());
        if (!$row) {
            $ret = $conn->execScript('INSERT INTO sign(accountid, sign_days, sign_time, item_id, item_num, create_time, modify_time) ' .
                                     ' VALUES(:accountid, :sign_days, :sign_time, 0, 0, :create_time, :modify_time) ' .
                                     ' ON DUPLICATE KEY UPDATE accountid=:accountid, sign_days=:sign_days, sign_time=:sign_time, item_id=0, item_num=0, modify_time=:modify_time;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':sign_days' => 1,
                                         ':sign_time' => time(),
                                         ':create_time' => time(),
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
                return;
            }
            $sign_days = 1;
            $signable = 0;
            $quest = new classes\Quest();
            $quest->triggerQuest(QUEST_DAY_LOGIN, 1, 1, $account_id);
            $quest->triggerQuest(QUEST_SUM_LOGIN, 2, 1, $account_id);
            //签到奖励
            $sign_meta_tables = require('../res/signDaily@signDaily.php');
            $day = $sign_days % count($sign_meta_tables);
            if ($day == 0) {
                $day = count($sign_meta_tables);
            }
            $s = $this->getSign($day + 90000);
            $item_id = $s['item_id'];
            $num = $s['num'];
            $addreward = new classes\AddReward();
            $addreward->addReward($item_id, $num, $account_id);
            $addreward->updateReward($item_id, $num, $account_id);
        } else {
            if ($nowTime - phpcommon\getdayseconds($row['sign_time']) > 0) {
                $sign_days = $row['sign_days'] + 1;
                $signable = 0;
                //刷新签到信息
                $retSign = $conn->execScript('UPDATE sign SET sign_time=:sign_time, sign_days=:sign_days, modify_time=:modify_time ' .
                                             ' WHERE accountid=:accountid;',
                                             array(
                                                 ':accountid' => $account_id,
                                                 ':sign_days' => $sign_days,
                                                 ':sign_time' => time(),
                                                 ':modify_time' => time()
                                             ));
                if (!$retSign) {
                    die();
                    return;
                }
                //签到奖励
                $sign_meta_tables = require('../res/signDaily@signDaily.php');
                $day = $sign_days % count($sign_meta_tables);
                if ($day == 0) {
                    $day = count($sign_meta_tables);
                }
                $s = $this->getSign($day + 90000);
                $item_id = $s['item_id'];
                $num = $s['num'];
                $addreward = new classes\AddReward();
                $addreward->addReward($item_id, $num, $account_id);
                $addreward->updateReward($item_id, $num, $account_id);
                //刷新每日任务和活动任务
                $rowCount = $conn->execQueryRowCount('SELECT * FROM quest WHERE accountid=:accountid;',
                                                     array(
                                                         ':accountid' => $account_id,
                                                     ));
                if ($rowCount != 0) {
                    for ($i = 0; $i < $rowCount; $i++) {
                        $ret = $conn->execScript('UPDATE quest SET quest_state=:quest_state, quest_num=:quest_num, modify_time=:modify_time ' .
                                                 ' WHERE accountid=:accountid AND quest_type=:quest_type1;',
                                                 array(
                                                     ':accountid' => $account_id,
                                                     ':quest_num' => 0,
                                                     ':quest_type1' => 1,
                                                     ':quest_state' => 0,
                                                     ':modify_time' => time()
                                                 ));
                    }
                    if (!$ret) {
                        die();
                        return;
                    }
                }
                $quest = new classes\Quest();
                $quest->triggerQuest(QUEST_DAY_LOGIN, 1, 1, $account_id);
                $quest->triggerQuest(QUEST_SUM_LOGIN, 2, 1, $account_id);
                //刷新战斗结算奖励次数,商店刷新次数,客服,免费宝箱
                $battle_ret = $conn->execScript('UPDATE user SET battle_re_times=0, shop_flush_times=0, kefu_status=0, free_getbox=0, modify_time=:modify_time ' .
                                                 ' WHERE accountid=:accountid;',
                                                 array(
                                                     ':accountid' => $account_id,
                                                     ':modify_time' => time()
                                                 ));
                if (!$battle_ret) {
                    die();
                    return;
                }
            } else {
                $sign_days = $row['sign_days'];
                $signable = 1;
            }
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
            'sign_days' => $sign_days,
            'signable' => $signable
        ));
    }
}
?>
